  ;000 OPTICAL MOUSE CONTROLLED BY PIC 03.ASM

  TITLE       "OPTICAL MOUSE CONTROLLED BY PIC 03"
  SUBTITLE    "Started 26.05.13 - Buenos Aires"
  SUBTITLE    "Updated 21.06.13"
  SUBTITLE    "Agustn Toms Ferrari Nicolay"
;------------------------------------------------------------------------------

;OPTICAL MOUSE CONTROLLED BY PIC 01

;Implemented xmision to / reception from a mouse as per PS/2 protocol.
;Testing done using the WRAP mode.

;OPTICAL MOUSE CONTROLLED BY PIC 02

;Implemented exhaustive verification of all possible codes, transmitted to the
;mouse as selected through a keyboard and buttons.


;OPTICAL MOUSE CONTROLLED BY PIC 03

;Code refined to cater for flexible reception of any reply from mouse where it
;could send 1, 2, 3, 4 or 5 bytes in a row.

;Be aware that using a timeout (TMR3 in this case) seems impossible to use a
;value that could fit all chips. ThHey seem to have different delays between
;the first and subsequent characters. See 019 INIT INTERRUPTS for details
;------------------------------------------------------------------------------

  Processor 18F4520
  LIST    B=4, C=80, MM=ON, R=DEC, ST=ON, T=OFF

  #INCLUDE <P18F4520.INC>
;------------------------------------------------------------------------------

  CONFIG    OSC =HS,        FCMEN =OFF,     IESO =OFF,      PWRT =ON
  CONFIG    BOREN =OFF,     BORV =0,        WDT =OFF,       WDTPS =32768
  CONFIG    CCP2MX =PORTBE, PBADEN =OFF,    LPT1OSC =OFF,   MCLRE =ON
  CONFIG    STVREN =OFF,    LVP =OFF,       XINST =OFF,     DEBUG =OFF
  CONFIG    CP0 =OFF,       CP1 =OFF,       CP2 =ON,        CP3 =OFF
  CONFIG    CPB =OFF,       CPD =OFF,       WRT0 =OFF,      WRT1 =OFF
  CONFIG    WRT2 =OFF,      WRT3 =OFF,      WRTC =OFF,      WRTB =OFF
  CONFIG    WRTD =OFF,      EBTR0 =OFF,     EBTR1 =OFF,     EBTR2 =OFF
  CONFIG    EBTR3 =OFF,     EBTRB =OFF
;------------------------------------------------------------------------------
    
  #INCLUDE "001 EQUS 01.ASM"
  #INCLUDE "002 EQUS 02.ASM"
  #INCLUDE "004 MACROS 01.ASM"
  #INCLUDE "005 MACROS 02.ASM"
  #INCLUDE "006 MACROS 03.ASM"

  ORG H'0000'                     ;reset vector
  BRA INIPROG

  ORG H'000008'                   ;high priority
                                  ;or compatibility mode interrupt vector
  BRA ISR_HIGH                    ;little space for an ISR here.

  NOP                             ;believe it - it's a placeholder man!
 
ISR_HIGH
  #INCLUDE "009 ISR HIGH.ASM"

INIPROG                           ;action starts here

;initialization starts here

  #INCLUDE "010 INIT SFR.ASM"
  #INCLUDE "012 INIT CLEAN RAM.ASM"
  #INCLUDE "014 INIT HARDWARE.ASM"
  #INCLUDE "015 INIT LCD.ASM"
  #INCLUDE "016 INIT GPR AND FLAGS.ASM"
  #INCLUDE "018 INIT FIRST INFO.ASM"     
  #INCLUDE "019 INIT INTERRUPTS.ASM"
  #INCLUDE "020 MAIN LOOP.ASM"

;initialization ends here
;------------------------------------------------------------------------------

;routines
  #INCLUDE "ROUT CLEAN RAM.ASM"
  #INCLUDE "ROUT CONVERSIONS.ASM"
  #INCLUDE "ROUT DECR COUNTERS.ASM"
  #INCLUDE "ROUT DELAYS.ASM"
  #INCLUDE "ROUT DISPLAY.ASM"
  #INCLUDE "ROUT KEYB MANAGER.ASM"
  #INCLUDE "ROUT KEYB SERV.ASM"
  #INCLUDE "ROUT LCD.ASM"
  #INCLUDE "ROUT MOUSE MANAGER.ASM"
  #INCLUDE "TABLES TEXT.ASM"

  END                             ;program ends here - Nice to meet you.
