  ;ROUT CONVERSIONS.ASM    18F family
    
;CONV_BCD6_NOT_PACKED_BIN24
;CONV_BCD5_NOT_PACKED_BIN16
;CONV_BIN16_BCD5_NOT_PACKED
;CONV_BIN16_BCD5_PACKED
;CONV_BIN24_BCD8_PACKED
;CONV_BIN_TO_BITPOS18
;CONV_BITPOS_TO_BIN18
;CONV_BITS_SETTING_TO_HEX
;CONV_BIN8_ASCII            - OK
;CONV_DIG_BCD_TO_DIG_ASCII  - OK
;------------------------------------------------------------------------------

;CONV_BCD6_NOT_PACKED_BIN24
;
;;This routine converts to binary the X rightmost BCD_DIG_ the 6 possible ones,
;;where X =PNTR_DIG_BCD (1 to 6 range) accesing registers sequentially,
;;using FSR.
;	
;;Example: given digits "FEDCBA" and PNTR_DIG_BCD =4, the routine will convert
;;to binary the digits "DCBA". (D is MSD and A is LSD)
;	
;;To call this routine: W =PNTR_DIG_BCD
;
;  MOVWF TEMP		;save valid digits count
;	MOVLW D'24'		;initializes the bit counter
;	MOVWF CNTR_GRAL	;3 bytes =24 bits
;
;D2BLP1
;
;	LOADREG TEMP,CMIL+5
;	MOVF PNTR_DIG_BCD,W
;	SUBWF TEMP,W	
;	MOVWF FSR		;FSR pointing to one place less than MSD
;	MOVF TEMP,W
;	MOVWF TEMP		;inner digit loop counter
;	MOVLW D'10'
;	BCF STATUS,C	;C =0 to make b7 of MSD =0
;
;D2BLP2
;
;	INCF FSR,F		;pointer increases and points to next digit
;	BTFSC STATUS,C	;???
;	
;	ADDWF INDF,F	;add 10 if a "1" came from prev digit
;	RRNCF INDF,F		;shift out LSB of digit
;	
;	DECFSZ TEMP,F	;reached last digit?
;	BRA D2BLP2		;not yet - go for next digit!
;	
;	RRNCF NROBIN_U,F	;shift in carry from digits
;	RRNCF	NROBIN_H,F
;	RRNCF	NROBIN_L,F
;	
;	DECFSZ CNTR_GRAL,F;reached last bit?
;	BRA D2BLP1		;not yet - go for next bit!
;	RETURN
;------------------------------------------------------------------------------

;CONV_BCD5_NOT_PACKED_BIN16
;
;;This routine converts five not-packed BCD_DIG_ to a 16 (17) bit binary.
;
;;To call this routine:
;;BCD digits in DIG_BCD_5(MSD) to DIG_BCD_1(LSD).
;
;;Output: 16-bit binary in NROBIN_H:NROBIN_L. If binary >65535, C =1.
;
;;Variables required:
;;DIG_BCD_5, DIG_BCD_4, DIG_BCD_3, DIG_BCD_2, DIG_BCD_1, NROBIN_H, NROBIN_L
;
;;DIG:BCD_5:1 are trashed out upon completion.
;
;  MOVF  DIG_BCD_2,W       ;(DIG_BCD_2 + DIG_BCD_4) *2
;  ADDWF DIG_BCD_4,W
;  MOVWF NROBIN_L
;  RLCF NROBIN_L,F
;
;  SWAPF DIG_BCD_3,W       ;+DIG_BCD_3*16 + DIG_BCD_3
;  ADDWF DIG_BCD_3,W
;  ADDWF NROBIN_L,F
;
;  RLCF DIG_BCD_5,W        ;+(DIG_BCD_5 *2 + DIG_BCD_4) *256
;  ADDWF DIG_BCD_4,W
;  MOVWF NROBIN_H
;
;  RLCF NROBIN_L,F         ;*2
;  RLCF NROBIN_H,F
;
;  SWAPF DIG_BCD_4,W       ;-DIG_BCD_4 *16
;  SUBWF NROBIN_L,F
;  BTFSS STATUS,C
;  DECF  NROBIN_H,F
;
;  SWAPF DIG_BCD_3,W       ;+DIG_BCD_3 *16 + DIG_BCD_2
;  ADDWF DIG_BCD_2,W
;  ADDWF NROBIN_L,F
;  BTFSC STATUS,C
;  INCF  NROBIN_H,F
;  
;  SWAPF DIG_BCD_5,W       ;+DIG_BCD_5 *16 + DIG_BCD_1
;  ADDWF DIG_BCD_1,W
;
;  RLCF NROBIN_L,F         ;*2
;  RLCF NROBIN_H,F
;
;  ADDWF NROBIN_L,F
;  BTFSC STATUS,C
;  INCF  NROBIN_H,F
;
;  MOVF  DIG_BCD_5,W       ;-DIG_BCD_5*256
;  SUBWF NROBIN_H,F
;
;  SWAPF DIG_BCD_5,W       ;+DIG_BCD_5 *16 *256 *2
;  ADDWF NROBIN_H,F
;  ADDWF NROBIN_H,F
;  RETURN
;------------------------------------------------------------------------------

;CONV_BIN16_BCD5_NOT_PACKED
;
;;To call this routine:
;;Binary number in NROBIN_H:NROBIN_L
;
;;Output (not packed) in DIG_BCD_5:DIG_BCD_1
;
;;Variables used:
;;CNTR_GRAL, TEMP, NROBIN_H, NROBIN_L plus
;
;;DIG_BCD_5 also named DIG_BCD_65    ;make sure of this in the EQUS section
;;DIG_BCD_4
;;DIG_BCD_3 also named DIG_BCD_43    ;make sure of this in the EQUS section
;;DIG_BCD_2
;;DIG_BCD_1 also named DIG_BCD_21    ;make sure of this in the EQUS section
;
;  RCALL CONV_BIN16_BCD5_PACKED ;output in DIG_BCD_65:DIG_BCD_21
;  
;  SWAPF DIG_BCD_21,W
;  MOVWF DIG_BCD_2
;  
;  SWAPF DIG_BCD_43,W
;  MOVWF DIG_BCD_4
;  
;  MOVLW MASK_HI_NIBBLE
;  
;  ANDWF DIG_BCD_1,F
;  ANDWF DIG_BCD_2,F
;  ANDWF DIG_BCD_3,F
;  ANDWF DIG_BCD_4,F
;  RETURN
;;------------------------------------------------------------------------------
;
;CONV_BIN16_BCD5_PACKED
;
;;To call this routine:
;;Binary number in NROBIN_H:NROBIN_L
;
;;Output (packed) in DIG_BCD_65:DIG_BCD_43:DIG_BCD_21
;;Left nibble of DIG_BCD_65 is always =0).
;
;;Variables used:
;;CNTR_GRAL, TEMP, NROBIN_H, NROBIN_L, DIG_BCD_65, DIG_BCD_43, DIG_BCD_21
;
;  BCF STATUS,C                   ;C=0
;  LOADREG CNTR_GRAL,16           ;bits counter
;  CLRF DIG_BCD_65
;  CLRF DIG_BCD_43
;  CLRF DIG_BCD_21
;
;CONV_BIN16_BCD5_PACKED_LOOP
;  RLCF NROBIN_L,F
;  RLCF NROBIN_H,F
;  RLCF DIG_BCD_21,F
;  RLCF DIG_BCD_43,F
;  RLCF DIG_BCD_65,F
;  DECFSZ CNTR_GRAL,F
;  BRA ADJUST_DEC
;  RETURN
;  
;ADJUST_DEC
;  LFSR FSR1,DIG_BCD_21
;  RCALL ADJUST_BCD
;
;  LFSR FSR1,DIG_BCD_43
;  RCALL ADJUST_BCD
;  
;  LFSR FSR1,DIG_BCD_65
;  RCALL ADJUST_BCD
;  
;  BRA CONV_BIN16_BCD5_PACKED_LOOP
;
;ADJUST_BCD
;  MOVLW H'03'
;  ADDWF INDF1,W
;  MOVWF TEMP
;  BTFSC TEMP,3            ;checks if the result is >7
;  MOVWF INDF1
;  MOVLW H'30'
;  ADDWF INDF1,W
;  MOVWF TEMP
;  BTFSC TEMP,7            ;checks if the result is >7
;  MOVWF INDF1             ;saves as MSD
;  RETURN
;------------------------------------------------------------------------------

;CONV_BIN24_BCD8_PACKED
;
;;To call this routine:
;;Binary number in NROBIN_U:NROBIN_H:NROBIN_L
;
;;Output (packed) in DIG_BCD_87:DIG_BCD_65:DIG_BCD_43:DIG_BCD_21
;
;
;;Variables used:
;;CNTR_GRAL, TEMP, NROBIN_H, NROBIN_L, DIG_BCD_87, DIG_BCD_65, DIG_BCD_43, DIG_BCD_21
;
;;Variables to be allocated in sequence: DIG_BCD_21, DIG_BCD_43, DIG_BCD_65, DIG_BCD_87.
;
;  BCF STATUS,C                   ;C=0
;  LOADREG CNTR_GRAL,24           ;bits counter
;
;  CLRF DIG_BCD_87
;  CLRF DIG_BCD_65
;  CLRF DIG_BCD_43
;  CLRF DIG_BCD_21
;
;CONV_BIN24_BCD8_PACKED_LOOP
;  RLCF NROBIN_L,F
;  RLCF NROBIN_H,F
;  RLCF NROBIN_U,F
;  RLCF DIG_BCD_21,F
;  RLCF DIG_BCD_43,F
;  RLCF DIG_BCD_65,F
;  RLCF DIG_BCD_87,F
;  DECFSZ CNTR_GRAL,F
;  BRA ADJUST_DEC_24_8
;  RETURN
;  
;ADJUST_DEC_24_8
;  LFSR FSR1,DIG_BCD_21
;  RCALL ADJUST_BCD
;
;  LFSR FSR1,DIG_BCD_43
;  RCALL ADJUST_BCD
;  
;  LFSR FSR1,DIG_BCD_65
;  RCALL ADJUST_BCD
;  
;  LFSR FSR1,DIG_BCD_87
;  RCALL ADJUST_BCD_24_8
;  
;  BRA CONV_BIN24_BCD8_PACKED_LOOP
;
;ADJUST_BCD_24_8
;  MOVLW H'03'
;  ADDWF INDF1,W
;  MOVWF TEMP
;  BTFSC TEMP,3            ;checks if the result is >7
;  MOVWF INDF1
;  MOVLW H'30'
;  ADDWF INDF1,W
;  MOVWF TEMP
;  BTFSC TEMP,7            ;checks if the result is >7
;  MOVWF INDF1             ;saves as MSD
;  RETURN
;------------------------------------------------------------------------------

;CONV_BIN_TO_BITPOS18
;
;;given a binary value (1 to 8), this routine returns a byte (mask)
;;where one of the eights bits is =1 - lowest bit is 1 here, not 0!!!
;
;;to call this routine W =binary value (1 to 8)
;;output W =mask with only the respective bit =1
;;vars used: CNTR_GRAL & TEMP
;
;    MOVWF CNTR_GRAL            ;counter to decrease until =0
;    LOADREG TEMP,1            ;mask to be shifted (until counter =0)
;
;BIN_TO_BITPOS18_LOOP
;    DECFSZ CNTR_GRAL,F
;    BRA NEXT_BNTOBT18
;    MOVF TEMP,W                ;W =mask with respective bit =1
;    RETURN
;
;NEXT_BNTOBT18
;    BCF STATUS,C
;    RLCF TEMP,F
;    BRA BIN_TO_BITPOS18_LOOP
;------------------------------------------------------------------------------

;CONV_BITPOS_TO_BIN18
;
;;sin ADAPTAR A 18f
;
;;to call this routine W =mask with one one of the eight bits set
;;output W =binary value (1 to 8) corrresponding to the mask bit
;;vars used: CNTR_GRAL & TEMP
;
;    MOVWF TEMP                 ;mask to be shifted until TEMP =0
;    LOADREG CNTR_GRAL,1        ;counter to increase until TEMP =0
;
;BITPOS_TO_BIN18_LOOP
;    BCF STATUS,C
;    RRF TEMP,F
;    SKIP8_F_ZERO TEMP
;    BRA NEXT_BTTOBN18
;    MOVF CNTR_GRAL,W
;    RETURN
;
;NEXT_BTTOBN18
;    INCF CNTR_GRAL,F
;    BRA BITPOS_TO_BIN18_LOOP
;------------------------------------------------------------------------------

;CONV_BITS_SETTING_TO_HEX
;
;;This routine test one or more bits of a byte. For every bit tested, it loads
;;an ASCII code in the respective buffer, DIG_ASCII_x:
;
;;H'30' - "0" - bit is clear   
;;H'31' - "1" - bit is set     
;;H'78' - "x" - bit not tested 
;
;;TEMP holds a copy of the byte to be tested -
;;MASK_FOR_TEST: binary mask where bits =1 denote what bits of TEMP are tested.
;;Example: MASK_7610 (=00111100), TEMP bits 5, 4, 3, &1, are to be tested.
;;MASK_TEST register to hold the binary mask above.
;;To call this routine:
;
;;TEMP =copy of the byte to be tested.
;;MASK_FOR_TEST =mask of bits to be tested with respective bits set.
;;DIG_ASCII_7:DIG_ASCII_0 to record ASCII code for each bit.
;
;  MOVLW H'78'			          ;ASCII code for "x" to denote, "bit not tested"
;  MOVFF WREG,DIG_ASCII_7    ;Initially, bit not tested
;  MOVFF WREG,DIG_ASCII_6    ;Initially, bit not tested
;  MOVFF WREG,DIG_ASCII_5    ;Initially, bit not tested
;  MOVFF WREG,DIG_ASCII_4    ;Initially, bit not tested
;  MOVFF WREG,DIG_ASCII_3    ;Initially, bit not tested
;  MOVFF WREG,DIG_ASCII_2    ;Initially, bit not tested
;  MOVFF WREG,DIG_ASCII_1    ;Initially, bit not tested
;  MOVFF WREG,DIG_ASCII_0    ;Initially, bit not tested
;  
;  LOADREG MASK_TEST,MASK_FOR_TEST
;
;TEST_BIT_0              ;infomative label
;  BTFSS MASK_TEST,0
;  BRA TEST_BIT_1
;  LOADREG DIG_ASCII_0,H'30'
;  
;  BTFSC TEMP,0
;  BSF DIG_ASCII_0,0
;
;TEST_BIT_1
;  BTFSS MASK_TEST,1
;  BRA TEST_BIT_2
;  LOADREG DIG_ASCII_1,H'30'
;  
;  BTFSC TEMP,1
;  BSF DIG_ASCII_1,0    
;  
;TEST_BIT_2
;  BTFSS MASK_TEST,2
;  BRA TEST_BIT_3
;  LOADREG DIG_ASCII_2,H'30'
;  
;  BTFSC TEMP,2
;  BSF DIG_ASCII_2,0     
;  
;TEST_BIT_3
;  BTFSS MASK_TEST,3
;  BRA TEST_BIT_4
;  LOADREG DIG_ASCII_3,H'30'
;  
;  BTFSC TEMP,3
;  BSF DIG_ASCII_3,0
;
;TEST_BIT_4
;  BTFSS MASK_TEST,4
;  BRA TEST_BIT_5
;  LOADREG DIG_ASCII_4,H'30'
;  
;  BTFSC TEMP,4
;  BSF DIG_ASCII_4,0
;
;TEST_BIT_5
;  BTFSS MASK_TEST,5
;  BRA TEST_BIT_6
;  LOADREG DIG_ASCII_5,H'30'
;  
;  BTFSC TEMP,5
;  BSF DIG_ASCII_5,0
;
;TEST_BIT_6
;  BTFSS MASK_TEST,6
;  BRA TEST_BIT_7
;  LOADREG DIG_ASCII_6,H'30'
;  
;  BTFSC TEMP,6
;  BSF DIG_ASCII_6,0
;
;TEST_BIT_7
;  BTFSS MASK_TEST,7
;  BRA CONV_BITS_SETTING_TO_HEX_EXIT
;  LOADREG DIG_ASCII_7,H'30'
;  
;  BTFSC TEMP,7
;  BSF DIG_ASCII_7,0
;
;CONV_BITS_SETTING_TO_HEX_EXIT
;  RETURN
;------------------------------------------------------------------------------

CONV_BIN8_ASCII

;This routine converst the hex value of an 8-bit binary number to its two
;equivalent ASCII values to be employed as input for a display.

;To call this routine:
;Binary number in TEMP

;Output: two ASCII chars in DIG_ASCII_H:DIG_ASCII_L
;TEMP remains unchanged

  MOVF	TEMP,W          ;lower nibble available in W
  ANDLW	MASK_HI_NIBBLE	;high nibble masked off
  MOVWF	DIG_ASCII_L     ;keep a copy
  MOVLW 10		          ;substracting 10 will tell numbers from letters
  SUBWF DIG_ASCII_L,W
  MOVLW H'30'		        ;if (0 to 9) - would add ASCII offset for numbers
  BTFSC STATUS,C
  MOVLW H'37'		        ;it's (A to F) - add ASCII offset for letters
  ADDWF DIG_ASCII_L,F	  ;ASCII value to represent the lower nibble


  SWAPF	TEMP,W	        ;high nibble is the lower nibble in W
  ANDLW	MASK_HI_NIBBLE	;high nibble masked off
  MOVWF	DIG_ASCII_H     ;ready to process - copy it
  MOVLW 10		          ;substracting 10 will tell numbers from letters
  SUBWF DIG_ASCII_H,W
  MOVLW H'30'		        ;if (0 to 9) - would add ASCII offset for numbers
  BTFSC STATUS,C
  MOVLW H'37'		        ;it's (A to F) - add ASCII offset for letters
  ADDWF DIG_ASCII_H,F  	;ASCII value to represent the higher nibble
  RETURN
;------------------------------------------------------------------------------ 
 
;CONV_DIG_BCD_TO_DIG_ASCII2    ;BCD buffer to ASCII buffer
;
;;This routine converts each of the nine DIG_BCD_ (BCD buffer) to its ASCII
;;equivalent copying it to the respective DIG_ASCII_ in the ASCII buffer
;
;;Leading zeroes (A'0') in the ASCII buffer are eliminated by changing them into
;;spaces (A' '). The rightmost digit is not changed because it could be showing
;;a "0" like this => "-------0".
;
;;To call this routine no register is to be set in advance.
;;The BCD buffer (DIG_BCD_8:0) is NOT trashed out upon completion.
;
;  CALL CLEAN_DIG_ASCII ;makes all 12 digits from ASCII buffer =A'0'
;    
;	LFSR 0,DIG_BCD_0		  ;FSR0 points to rightmost digit from the BCD buffer.
;	LFSR 1,DIG_ASCII_0    ;FSR1 points to rightmost digit from the ASCII buffer.
;	LOADREG CNTR_GRAL,9   ;total of digits to transfer from buffer to buffer
;
;CONV_DIG_BCD_DIG_ASCII_LOOP
;  MOVLW H'30'           ;upper nibble to add, turning bin value into ASCII value.
;  IORWF POSTINC0,W      ;H'30' ORed - W =ASCII value
;  MOVWF POSTINC1        ;ASCII value copied to ASCII buffer pointed by FSR1.
;  DECFSZ CNTR_GRAL,F
;  BRA CONV_DIG_BCD_DIG_ASCII_LOOP
;  
;;Check 8 leftmost digits, to replace leading zeroes (A'0') with spaces (A' ').
;  
;	LFSR 0,DIG_ASCII_8    ;FSR1 points to leftmost digit from the ASCII buffer.
;	LOADREG CNTR_GRAL,7   ;seven digits to be checked.
;  LOADREG TEMP_LCD,A' ' ;TEMP =' ' to replace leading zeroes.
;
;CONV_BCD_ASCII_CLEAN_LEADLOOP
;  SKIP_R_EQU_V INDF0,H'30'  ;If digit holds a '0' (FSR unchanged)...
;  RETURN                    ;No leading zero - leave!
;  MOVFF TEMP_LCD,POSTDEC0   ;...replace by a space! (decrementing FSR)
;  DECFSZ CNTR_GRAL,F
;  BRA CONV_BCD_ASCII_CLEAN_LEADLOOP
;  RETURN
;------------------------------------------------------------------------------
 
 