  ;ROUT MOUSE MANAGER.ASM


;Enter here to read any bytes AFTER the first.
RCV_NEXT_FM_MOUSE             ;CLOCK & DATA asumed both high - IDLRE sate

  LOADREG TMR3H,H'FC'         ;TIMER3 to get timeout at 110 usec
  LOADREG TMR3L,H'49'         ;TIMER3 loaded with 64585 (950 counts to o'flow)
  
  BCF PIR2,TMR3IF             ;just in case, clear overflow flag
  BSF T3CON,TMR3ON            ;and launch timer!
  
NEXT_START_LOOP
  BTFSC PIR2,TMR3IF           ;if flag set means that we've spent 110 usec
  RETURN                      ;no byte will come - abandon now!
  BTFSC PIN_CLK_IN            ;if CLK is low, a byte starts
  BRA NEXT_START_LOOP         ;CLK still high - back to check again.
  BRA NEW_BYTE_STARTED
;******************************************************************************

;Enter here to read the FISRT byte from mouse.
RCV_1ST_FM_MOUSE              ;CLOCK & DATA asumed both high - IDLRE sate
  
  CHK_WHEN_CLK_IS_LO          ;check when START pulse starts (no pun intended)

NEW_BYTE_STARTED
  BCF T3CON,TMR3ON            ;new byte is being received - stop timer!
  
  DELAY_AFTER
  BTFSC PIN_DATA_IN
  BRA FALSE_START
  CHK_WHEN_CLK_IS_HI          ;START pulse ends here
  
  LOADREG CNTR_BITS_RCVD,8
  CLRF CNTR_PARITY
  CLRF BUFF_BITS_RCVD
  
RCV_DATA_BITS
  CHK_WHEN_CLK_IS_LO          ;DATA pulse starts here
  DELAY_AFTER
  
  BCF STATUS,C                ;we asume DATA will be 0
  BTFSS PIN_DATA_IN
  BRA ENTER_BIT_IN_BUFFER     ;yes, it was 0               
  INCF CNTR_PARITY,F          ;no, DATA was 1
  BSF STATUS,C                ;now, we set Carry to flag data bit =1
  
ENTER_BIT_IN_BUFFER  
  RRCF BUFF_BITS_RCVD,F       ;b7 gets data from Carry and all move one step in
  CHK_WHEN_CLK_IS_HI          ;DATA pulse ends here
  
  DECFSZ CNTR_BITS_RCVD,F     ;if all bits received, you jump...
  BRA RCV_DATA_BITS           ; not all! go back to receive the next!
  
RCV_PARITY_BIT                ;...to here - 8 data bits are in BUFF_BITS_RCVD
  CHK_WHEN_CLK_IS_LO          ;PARITY bit pulse starts here
  DELAY_AFTER

  BTFSC PIN_DATA_IN
  BRA PARITY_BIT_IS_HI
  BTFSS CNTR_PARITY,0
  BRA WRONG_PARITY
  
END_PARITY_BIT_PULSE_RD
  CHK_WHEN_CLK_IS_HI          ;PARITY bit pulse ends here
  DELAY_AFTER

RCV_STOP_BIT
  CHK_WHEN_CLK_IS_LO          ;STOP pulse starts here
  DELAY_AFTER

  BTFSS PIN_DATA_IN
  BRA NO_STOP
  CHK_WHEN_CLK_IS_HI          ;STOP pulse ends here
  
  RETURN
;------------------------------------------------------------------------------

PARITY_BIT_IS_HI
  BTFSC CNTR_PARITY,0
  BRA WRONG_PARITY
  BRA END_PARITY_BIT_PULSE_RD
  
FALSE_START
  SHOW_LCD_LINE	H'40',TEXT_FALSE_START
  RETURN
  
WRONG_PARITY
  SHOW_LCD_LINE	H'40',TEXT_WRONG_PARITY
  RETURN 
  
NO_STOP
  SHOW_LCD_LINE	H'40',TEXT_NO_STOP
  RETURN
;******************************************************************************

XMT_TO_MOUSE                  ;routine to transmit a byte to be read by mouse
  MOVFF TEMP,BUFF_BYTE_TO_XMT ;byte to be sent
  BSF BIT_FOR_ODD             ;asume even number of ones, make parity bit =1
  BTFSC BUFF_BYTE_TO_XMT,0    ;check actual No of ones
  BCF BIT_FOR_ODD             ;it is odd number of ones - make parity bit =0
  
  MAKE_PIN_CLK_OUT_LO         ;starting to get attention from mouse
  CALL DELAY_110_MICR         ;for at least 100 usec.
  MAKE_PIN_DATA_OUT_LO        ;telling the mouse "here we go - receive!"
  MAKE_PIN_CLK_OUT_HI         ;hey, mouse - give me your best clock!!
  LOADREG CNTR_BITS_TO_XMT,8  ;a byte has 8 bits - that is what they say...
  DELAY_AFTER

XMT_NEXT_DATA_BIT
  CHK_WHEN_CLK_IS_LO          ;DATA bit pulse starts here.
  DELAY_AFTER
  RRCF BUFF_BYTE_TO_XMT       ;bring LS bit into C
  BTFSS STATUS,C              ; if C =1...
  BRA PIN_DATA_XMT_TO_BE_LO   ;no, C =0, a 0 must go in DATA
  MAKE_PIN_DATA_OUT_HI        ;...put a 1 in the DATA
  
END_DATA_BIT_XMT
  CHK_WHEN_CLK_IS_HI          ;DATA bit pulse ends here.
  DECFSZ CNTR_BITS_TO_XMT     ;did we xmit all already?
  BRA XMT_NEXT_DATA_BIT       ;no, more to xmit - go back.
  CHK_WHEN_CLK_IS_LO          ;PARITY pulse starts here.
  DELAY_AFTER
  BTFSS BIT_FOR_ODD           ;check parity bit calculated prior starting
  BRA PARITY_DATA_OUT_TO_BE_LO;go and make parity bit to xmit =0
  MAKE_PIN_DATA_OUT_HI        ;make parity bit to xmit =1
  
END_PARITY_BIT_XMT
  CHK_WHEN_CLK_IS_HI          ;PARITY pulse ends here.
  DELAY_AFTER
  
  CHK_WHEN_CLK_IS_LO          ;STOP pulse starts here
  DELAY_AFTER
  MAKE_PIN_DATA_OUT_HI        ;we materialize the STOP bit
  CHK_WHEN_CLK_IS_HI          ;STOP pulse ends here
  DELAY_AFTER
  
  CHK_WHEN_CLK_IS_LO          ;ACK pulse starts here
  DELAY_AFTER
  BTFSC PIN_DATA_IN           ;reading DATA - did mouse acknoledged our byte?
  BRA NOT_ACK                 ;no, the mouse didn't!
  CHK_WHEN_CLK_IS_HI          ;ACK pulse ends here - SUCCESS!
  RETURN
;------------------------------------------------------------------------------

PIN_DATA_XMT_TO_BE_LO
  MAKE_PIN_DATA_OUT_LO
  BRA END_DATA_BIT_XMT
  
PARITY_DATA_OUT_TO_BE_LO
  MAKE_PIN_DATA_OUT_LO
  BRA END_PARITY_BIT_XMT

NOT_ACK
  SHOW_LCD_LINE	H'40',TEXT_NOT_ACK
  RETURN

;******************************************************************************
    
XMT_ONE_TO_MOUSE                  ;byte in TEMP
  CALL CONV_BIN8_ASCII
  MOVFF DIG_ASCII_H,BUFF_DISP_11
  MOVFF DIG_ASCII_L,BUFF_DISP_10
  CALL XMT_TO_MOUSE
  RETURN
;------------------------------------------------------------------------------

PROCESS_ONE_ONE
  CALL XMT_ONE_TO_MOUSE           ;SEND one
  CALL RCV_ONE_FM_MOUSE           ;RECEIVE one
  CALL SHOW_RCVD_BYTES            ;show it to the world with pride!
  RETURN

PROCESS_ONE_MANY
  CALL XMT_ONE_TO_MOUSE           ;SEND one
  CALL RCV_MANY_FM_MOUSE          ;RECEIVE more than one
  CALL SHOW_RCVD_BYTES            ;show them to the world with joy!
  RETURN
;------------------------------------------------------------------------------

RCV_ONE_FM_MOUSE
  CALL RCV_1ST_FM_MOUSE
  MOVFF BUFF_BITS_RCVD,TEMP
  CALL CONV_BIN8_ASCII
  MOVFF DIG_ASCII_H,BUFF_DISP_9
  MOVFF DIG_ASCII_L,BUFF_DISP_8
  RETURN

RCV_MANY_FM_MOUSE
  CALL RCV_ONE_FM_MOUSE           ;go for the first byte (there is always one)
  CALL RCV_NEXT_FM_MOUSE          ;go for the second
  BTFSC PIR2,TMR3IF
  BRA LAST_RCVD  
  MOVFF BUFF_BITS_RCVD,TEMP
  CALL CONV_BIN8_ASCII
  MOVFF DIG_ASCII_H,BUFF_DISP_7
  MOVFF DIG_ASCII_L,BUFF_DISP_6
  
  CALL RCV_NEXT_FM_MOUSE          ;go for the third
  BTFSC PIR2,TMR3IF
  BRA LAST_RCVD  
  MOVFF BUFF_BITS_RCVD,TEMP
  CALL CONV_BIN8_ASCII
  MOVFF DIG_ASCII_H,BUFF_DISP_5
  MOVFF DIG_ASCII_L,BUFF_DISP_4
  
  CALL RCV_NEXT_FM_MOUSE          ;go for the fourth
  BTFSC PIR2,TMR3IF
  BRA LAST_RCVD  
  MOVFF BUFF_BITS_RCVD,TEMP
  CALL CONV_BIN8_ASCII
  MOVFF DIG_ASCII_H,BUFF_DISP_3
  MOVFF DIG_ASCII_L,BUFF_DISP_2
  
  CALL RCV_NEXT_FM_MOUSE          ;go for the fifth
  BTFSC PIR2,TMR3IF
  BRA LAST_RCVD  
  MOVFF BUFF_BITS_RCVD,TEMP
  CALL CONV_BIN8_ASCII
  MOVFF DIG_ASCII_H,BUFF_DISP_1
  MOVFF DIG_ASCII_L,BUFF_DISP_0
  
RCV_MANY_DONE
  RETURN
  
LAST_RCVD
  BCF T3CON,TMR3ON                ;no more expected - stop timer!
  BCF PIR2,TMR3IF                 ;reset overflow flag - tidy up all - good boy
  BRA RCV_MANY_DONE
;------------------------------------------------------------------------------

SHOW_RCVD_BYTES
  LOADREG TEMP_LCD,H'05'          ;locate cursor
  RCALL LCD_CRSR_LOCATE
  CALL DISPLAY_BYTE_TO_MOUSE
  
  LOADREG TEMP_LCD,H'45'          ;locate cursor
  RCALL LCD_CRSR_LOCATE
  CALL DISPLAY_BYTES_FM_MOUSE     ;valid ones show only - the rest are blank
  RETURN
;------------------------------------------------------------------------------

DISPLAY_BYTE_TO_MOUSE             ;cursor to be located already
  MOVFF BUFF_DISP_11,TEMP_LCD     ;show digit in high byte
  RCALL LCD_WRITE_DATA
  MOVFF BUFF_DISP_10,TEMP_LCD     ;show digit in low byte
  RCALL LCD_WRITE_DATA
  RETURN
;------------------------------------------------------------------------------

DISPLAY_BYTES_FM_MOUSE            ;cursor to be located already
  MOVFF BUFF_DISP_9,TEMP_LCD      ;show digit in high byte
  RCALL LCD_WRITE_DATA
  MOVFF BUFF_DISP_8,TEMP_LCD      ;show digit in low byte
  RCALL LCD_WRITE_DATA
  LOADREG TEMP_LCD, A' '          ;show a space
  RCALL LCD_WRITE_DATA
  
  MOVFF BUFF_DISP_7,TEMP_LCD      ;show digit in high byte
  RCALL LCD_WRITE_DATA
  MOVFF BUFF_DISP_6,TEMP_LCD      ;show digit in low byte
  RCALL LCD_WRITE_DATA
  LOADREG TEMP_LCD, A' '          ;show a space
  RCALL LCD_WRITE_DATA
  LOADREG BUFF_DISP_7,H'20'       ;preventive erasing - space
  LOADREG BUFF_DISP_6,H'20'       ;preventive erasing - space
  
  MOVFF BUFF_DISP_5,TEMP_LCD      ;show digit in high byte
  RCALL LCD_WRITE_DATA
  MOVFF BUFF_DISP_4,TEMP_LCD      ;show digit in low byte
  RCALL LCD_WRITE_DATA
  LOADREG TEMP_LCD, A' '          ;show a space
  RCALL LCD_WRITE_DATA
  LOADREG BUFF_DISP_5,H'20'       ;preventive erasing - space
  LOADREG BUFF_DISP_4,H'20'       ;preventive erasing - space
  
  MOVFF BUFF_DISP_3,TEMP_LCD      ;show digit in high byte
  RCALL LCD_WRITE_DATA
  MOVFF BUFF_DISP_2,TEMP_LCD      ;show digit in low byte
  RCALL LCD_WRITE_DATA
  LOADREG TEMP_LCD, A' '          ;show a space
  RCALL LCD_WRITE_DATA
  LOADREG BUFF_DISP_3,H'20'       ;preventive erasing - space
  LOADREG BUFF_DISP_2,H'20'       ;preventive erasing - space
  
  MOVFF BUFF_DISP_1,TEMP_LCD      ;show digit in high byte
  RCALL LCD_WRITE_DATA
  MOVFF BUFF_DISP_0,TEMP_LCD      ;show digit in low byte
  RCALL LCD_WRITE_DATA
  LOADREG TEMP_LCD, A' '          ;show a space
  RCALL LCD_WRITE_DATA
  LOADREG BUFF_DISP_1,H'20'       ;preventive erasing - space
  LOADREG BUFF_DISP_0,H'20'       ;preventive erasing - 
  RETURN
  